unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Types, Forms, Controls, Graphics, Dialogs, ExtCtrls, ComCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    TrackBar1: TTrackBar;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
  private
    FPicture: TPicture;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  Math, GraphMath,
  FPImage, IntfGraphics;

function RotateImage(ASourceImg: TLazIntfImage; Angle: Double): TLazIntfImage;
var
  R: TRect;
  x, y: Integer;
  C, P: TPoint;
begin
  R := RotateRect(ASourceImg.Width, ASourceImg.Height, Angle);
  OffsetRect(R, -R.Left, -R.Top);
  Result := TLazIntfImage.CreateCompatible(ASourceImg, R.Width, R.Height);
  C := Point(R.Width div 2, R.Height div 2);
  for y := 0 to Result.Height-1 do
    for x := 0 to Result.Width-1 do
    begin
      P := RotatePoint(Point(x, y) - C, -Angle) + C;
      P := P - Point((Result.Width - ASourceImg.Width) div 2, (Result.Height - ASourceImg.Height) div 2);
      if (P.X >= 0) and (P.Y >= 0) and (P.X < ASourceImg.Width) and (P.Y < ASourceImg.Height) then
        Result.Colors[x, y] := ASourceImg.Colors[P.X, P.Y]
      else
        Result.Colors[x, y] := colTransparent;
    end;
end;


{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  FPicture := TPicture.Create;
  FPicture.LoadFromFile('2.png');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FPicture.Destroy;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var
  imgSrc, imgDest: TLazIntfImage;
  bmp: TBitmap;
begin
  if Trackbar1.Position = 0 then
    Paintbox1.Canvas.Draw(
      (Paintbox1.Width - FPicture.Width) div 2,
      (Paintbox1.Height - FPicture.Height) div 2,
      FPicture.Graphic
    )
  else
  begin
    imgSrc := FPicture.PNG.CreateIntfImage;
    imgDest := RotateImage(imgSrc, DegToRad(Trackbar1.Position));
    bmp := TBitmap.Create;
    bmp.Pixelformat := pf32Bit;
    bmp.LoadFromIntfImage(imgDest);
    Paintbox1.Canvas.Draw(
      (Paintbox1.Width - bmp.Width) div 2,
      (Paintbox1.Height - bmp.Height) div 2,
      bmp
    );
    bmp.Free;
    imgDest.Free;
    imgSrc.Free;
  end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  Paintbox1.Invalidate;
end;

end.

